import AudioManager from "./audioManager.js";



// Audio manager class for handling audio playback.
let audioManager = null;
// to store buffer
let whooshSample = null;
// to store sliders
let attackUpdate = null;
let decayUpdate = null;
let re_sampleUpdate = null;
let speedUpdate = null;

runOnStartup(async runtime =>
{
	// add event listener
	runtime.addEventListener("beforeprojectstart", () => OnBeforeProjectStart(runtime));
	
	
	// Initialise the audio manager. See AudioManager.js for details.
	audioManager = new AudioManager(runtime);
	
	// During the loading screen, load both sound files as
	// AudioBuffers and the music track all in parallel, so
	// they are ready for immediate playback on startup.
	//[footstepsAudio1, footstepsAudio2, footstepsAudio3] = await Promise.all([
	[whooshSample] = await Promise.all([
		audioManager.loadSound("Whoosh_SpaceShip_PassBy_Stereo-001.webm")
		
	]);
});

async function OnBeforeProjectStart(runtime)
{
	// get reference to object (slider) in the scene layout
	attackUpdate = runtime.objects.attackS.getFirstInstance();
	decayUpdate = runtime.objects.decayS.getFirstInstance();
	re_sampleUpdate = runtime.objects.ReSampleS.getFirstInstance();
	speedUpdate = runtime.objects.speedS.getFirstInstance();
	
	// Add an "input" event to each of the sliders to update the effect parameters.
	// (Note "input" fires while dragging the slider, but "change" only fires when
	// the slider stops being dragged.)
	attackUpdate.addEventListener("input", UpdateParameters);
	decayUpdate.addEventListener("input", UpdateParameters);
	re_sampleUpdate.addEventListener("input", UpdateParameters);
	speedUpdate.addEventListener("input", UpdateParameters);
}

function UpdateParameters()
{
	attackUpdate.value;
	//console.log(attackUpdate.value)
	
	decayUpdate.value;
	//console.log(decayUpdate.value)
	
	re_sampleUpdate.value;
	//console.log(re_sampleUpdate.value)
	
	speedUpdate.value;
	//console.log(speedUpdate.value)

}

export function playSample()
{
//playSound(audioBuffer, delayStartTime, attack, decay, playSpeed, resample_by)
	audioManager.playSound(whooshSample, 0, attackUpdate.value, decayUpdate.value, speedUpdate.value, re_sampleUpdate.value);
}








